// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias DeleteChatPhotoCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to delete a chat photo. Photos can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletechatphoto>
    @discardableResult
    public func deleteChatPhotoSync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("deleteChatPhoto", defaultParameters["deleteChatPhoto"], parameters, [
            "chat_id": chatId])
    }

    /// Use this method to delete a chat photo. Photos can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletechatphoto>
    public func deleteChatPhotoAsync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: DeleteChatPhotoCompletion? = nil) {
        return requestAsync("deleteChatPhoto", defaultParameters["deleteChatPhoto"], parameters, [
            "chat_id": chatId],
            queue: queue, completion: completion)
    }
}

