// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias DeleteChatStickerSetCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to delete a group sticker set from a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field can_set_sticker_set optionally returned in getChat requests to check if the bot can use this method. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername)
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletechatstickerset>
    @discardableResult
    public func deleteChatStickerSetSync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("deleteChatStickerSet", defaultParameters["deleteChatStickerSet"], parameters, [
            "chat_id": chatId])
    }

    /// Use this method to delete a group sticker set from a supergroup. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Use the field can_set_sticker_set optionally returned in getChat requests to check if the bot can use this method. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup (in the format @supergroupusername)
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletechatstickerset>
    public func deleteChatStickerSetAsync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: DeleteChatStickerSetCompletion? = nil) {
        return requestAsync("deleteChatStickerSet", defaultParameters["deleteChatStickerSet"], parameters, [
            "chat_id": chatId],
            queue: queue, completion: completion)
    }
}

