// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias DeleteMessageCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to delete a message, including service messages, with the following limitations:
    /// - A message can only be deleted if it was sent less than 48 hours ago.
    /// - Bots can delete outgoing messages in groups and supergroups.
    /// - Bots granted can_post_messages permissions can delete outgoing messages in channels.
    /// - If the bot is an administrator of a group, it can delete any message there.
    /// - If the bot has can_delete_messages permission in a supergroup or a channel, it can delete any message there.
    /// Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Identifier of the message to delete
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletemessage>
    @discardableResult
    public func deleteMessageSync(
            chatId: ChatId,
            messageId: Int,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("deleteMessage", defaultParameters["deleteMessage"], parameters, [
            "chat_id": chatId,
            "message_id": messageId])
    }

    /// Use this method to delete a message, including service messages, with the following limitations:
    /// - A message can only be deleted if it was sent less than 48 hours ago.
    /// - Bots can delete outgoing messages in groups and supergroups.
    /// - Bots granted can_post_messages permissions can delete outgoing messages in channels.
    /// - If the bot is an administrator of a group, it can delete any message there.
    /// - If the bot has can_delete_messages permission in a supergroup or a channel, it can delete any message there.
    /// Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Identifier of the message to delete
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletemessage>
    public func deleteMessageAsync(
            chatId: ChatId,
            messageId: Int,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: DeleteMessageCompletion? = nil) {
        return requestAsync("deleteMessage", defaultParameters["deleteMessage"], parameters, [
            "chat_id": chatId,
            "message_id": messageId],
            queue: queue, completion: completion)
    }
}

