// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetChatMemberCompletion = (_ result: ChatMember?, _ error: DataTaskError?) -> ()

    /// Use this method to get information about a member of a chat. Returns a ChatMember object on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
    ///     - user_id: Unique identifier of the target user
    /// - Returns: ChatMember on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getchatmember>
    @discardableResult
    public func getChatMemberSync(
            chatId: ChatId,
            userId: Int64,
            _ parameters: [String: Any?] = [:]) -> ChatMember? {
        return requestSync("getChatMember", defaultParameters["getChatMember"], parameters, [
            "chat_id": chatId,
            "user_id": userId])
    }

    /// Use this method to get information about a member of a chat. Returns a ChatMember object on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
    ///     - user_id: Unique identifier of the target user
    /// - Returns: ChatMember on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getchatmember>
    public func getChatMemberAsync(
            chatId: ChatId,
            userId: Int64,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetChatMemberCompletion? = nil) {
        return requestAsync("getChatMember", defaultParameters["getChatMember"], parameters, [
            "chat_id": chatId,
            "user_id": userId],
            queue: queue, completion: completion)
    }
}

