// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias StopMessageLiveLocationCompletion = (_ result: MessageOrBool?, _ error: DataTaskError?) -> ()

    /// Use this method to stop updating a live location message sent by the bot or via the bot (for inline bots) before live_period expires. On success, if the message was sent by the bot, the sent Message is returned, otherwise True is returned.
    /// - Parameters:
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    ///     - reply_markup: A JSON-serialized object for a new inline keyboard.
    /// - Returns: MessageOrBool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#stopmessagelivelocation>
    @discardableResult
    public func stopMessageLiveLocationSync(
            chatId: ChatId? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            replyMarkup: InlineKeyboardMarkup? = nil,
            _ parameters: [String: Any?] = [:]) -> MessageOrBool? {
        return requestSync("stopMessageLiveLocation", defaultParameters["stopMessageLiveLocation"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId,
            "reply_markup": replyMarkup])
    }

    /// Use this method to stop updating a live location message sent by the bot or via the bot (for inline bots) before live_period expires. On success, if the message was sent by the bot, the sent Message is returned, otherwise True is returned.
    /// - Parameters:
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    ///     - reply_markup: A JSON-serialized object for a new inline keyboard.
    /// - Returns: MessageOrBool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#stopmessagelivelocation>
    public func stopMessageLiveLocationAsync(
            chatId: ChatId? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            replyMarkup: InlineKeyboardMarkup? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: StopMessageLiveLocationCompletion? = nil) {
        return requestAsync("stopMessageLiveLocation", defaultParameters["stopMessageLiveLocation"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId,
            "reply_markup": replyMarkup],
            queue: queue, completion: completion)
    }
}

