// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias UploadStickerFileCompletion = (_ result: File?, _ error: DataTaskError?) -> ()

    /// Use this method to upload a .png file with a sticker for later use in createNewStickerSet and addStickerToSet methods (can be used multiple times). Returns the uploaded File on success.
    /// - Parameters:
    ///     - user_id: User identifier of sticker file owner
    ///     - png_sticker: Png image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. More info on Sending Files »
    /// - Returns: File on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#uploadstickerfile>
    @discardableResult
    public func uploadStickerFileSync(
            userId: Int64,
            pngSticker: InputFile,
            _ parameters: [String: Any?] = [:]) -> File? {
        return requestSync("uploadStickerFile", defaultParameters["uploadStickerFile"], parameters, [
            "user_id": userId,
            "png_sticker": pngSticker])
    }

    /// Use this method to upload a .png file with a sticker for later use in createNewStickerSet and addStickerToSet methods (can be used multiple times). Returns the uploaded File on success.
    /// - Parameters:
    ///     - user_id: User identifier of sticker file owner
    ///     - png_sticker: Png image with the sticker, must be up to 512 kilobytes in size, dimensions must not exceed 512px, and either width or height must be exactly 512px. More info on Sending Files »
    /// - Returns: File on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#uploadstickerfile>
    public func uploadStickerFileAsync(
            userId: Int64,
            pngSticker: InputFile,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: UploadStickerFileCompletion? = nil) {
        return requestAsync("uploadStickerFile", defaultParameters["uploadStickerFile"], parameters, [
            "user_id": userId,
            "png_sticker": pngSticker],
            queue: queue, completion: completion)
    }
}

